#!/usr/bin/env python
	
# Authors:Xiaohong Zhuang, Dr.Jeffery B. Klauda
# Date: 9/27/2015
# Generate cmp for glycerolphospholipids(gl), Sphigolipids(sl), Cardiolipin(dl), and Sterol/Cholesterol(cl)

# Read lipid name
fob = open('lip_lower.txt','r')
lip = fob.readline()
lip = lip.strip()

# Generate group based on lip-atmlbl.txt
filetoread = "%s-atmlbl-sed.txt" % lip
fob=open(filetoread,'r')
atmlbl=fob.readlines()

# Function of printing the NamGrp, NumAtoms, NamAtoms
def prnA(GrpAtms,Grp):
	for i in range(0,len(Grp),1):
		print Grp[i],'\t',len(GrpAtms[Grp[i]]),'\t', '\t'.join(GrpAtms[Grp[i]])

# Function of grouping the atoms. Abbrev.: pre=(near)Prefixes, suf=Suffixes
TGrpAtms={};TGrpAtms['C']=[];TGrpAtms['CH']=[];TGrpAtms['CH2']=[];TGrpAtms['CH3']=[];TGrpAtms['Cyc']=[]
def grpA(Tatmnlist,N_1stc,Ind_c,c_pre,c_suf,h1_suf,h2_suf,h3_suf,ho_suf):
	clist=[];
	for j in range (0,len(Tatmnlist),1):
		letters = map(lambda s: s.strip(), Tatmnlist[j])
		if lip_type == 'gl' or lip_type == 'dl' :
			if letters[0]=='c' and letters[Ind_c]==c_pre:
				clist.append(Tatmnlist[j]);
		elif lip_type == 'sl':
			if letters[0]=='c' and letters[Ind_c]==c_suf:
				clist.append(Tatmnlist[j])
		elif lip_type == 'cl':
			if letters[0]=='c':
				clist.append(Tatmnlist[j])
	for k in range(N_1stc,len(clist)+N_1stc,1):
		c='c'+c_pre+str(k)+c_suf; h1='h'+str(k)+h1_suf; h2='h'+str(k)+h2_suf; h3='h'+str(k)+h3_suf; ho='h'+str(k)+ho_suf;
		if h3 in Tatmnlist:
			TGrpAtms['CH3'].append(c);TGrpAtms['CH3'].append(h1);TGrpAtms['CH3'].append(h2);TGrpAtms['CH3'].append(h3);
		elif h2 in Tatmnlist:	
			TGrpAtms['CH2'].append(c);TGrpAtms['CH2'].append(h1);TGrpAtms['CH2'].append(h2);
		elif h1 in Tatmnlist:
			TGrpAtms['CH'].append(c);TGrpAtms['CH'].append(h1);
		elif ho in Tatmnlist:
			TGrpAtms['CH'].append(c);TGrpAtms['CH'].append(ho);
		else: 
			TGrpAtms['C'].append(c);
		if (lip[0:2]=='qm' or lip[0:2]=='pm') and h1_suf=='r':
			if k==9 or k==10:
				TGrpAtms['Cyc'].append(c);TGrpAtms['Cyc'].append(h1);
				TGrpAtms['CH'].remove(c);TGrpAtms['CH'].remove(h1);
			elif k ==17:
				TGrpAtms['Cyc'].append(c);TGrpAtms['Cyc'].append(h1);TGrpAtms['Cyc'].append(h2);
				TGrpAtms['CH2'].remove(c);TGrpAtms['CH2'].remove(h1);TGrpAtms['CH2'].remove(h2);			
	return TGrpAtms

# Print Head lines
print """#################################################################################
##
## H2 model [Klauda et al., BJ 90 (2006) 2796-2807] is defined as follows:
##14X"""

### Head Groups
# Define head for gl
head = 'NA'; lip_type = 'NA';
if lip[-1]!='u' and len(lip)==4:
	 head = lip[2:];
if lip[-1]=='u' and len(lip)==5:
	head = lip[2:4];                          

# Determine lipid type based on lipid name:
if head == 'pa' or head == 'pc' or head == 'pe' or head == 'pi' or head == 'pg' or head == 'ps':
	lip_type = 'gl'
elif ('sm' in lip) or ('cer' in lip) or ('cr' in lip):
	lip_type = 'sl'
elif 'cl1' in lip or 'cl2' in lip:
	lip_type = 'dl'	
elif lip=='chl1' or lip=='erg' or lip=='sito' or lip=='stig':
	lip_type = 'cl'
elif lip == 'tip3':
	lip_type = 'tip3'
elif lip == 'pot':
	lip_type = 'pot'
else: 
	print 'ERROR! Unkown lipid type!'

## Head group atom names
HGrpAtms={'Acid':['h12'],
'Chol':['n','c13','h13a','h13b','h13c','c14','h14a','h14b','h14c','c15','h15a','h15b','h15c','c12','h12a','h12b','c11','h11a','h11b'],
'EolAm':['n','hn1','hn2','hn3','c12','h12a','h12b','c11','h11a','h11b'],
'Inos':['c12','h2','o2','ho2','c13','h3','o3','ho3','c14','h4','o4','ho4','c15','h5','o5','ho5','c16','h6','o6','ho6','c11','h1'],
'GlyH':['c13','h13a','h13b','oc3','ho3','c12','h12a','oc2','ho2','c11','h11a','h11b'],
'Ser':['n','hn1','hn2','hn3','c12','h12a','c13','o13a','o13b','c11','h11a','h11b'],
'Phos':['p','o13','o14','o11','o12'],
'Gly':['c1','ha','hb','c2','hs','o21','c3','hx','hy','o31'],
'Carb':['c21','o22','c31','o32'],
'OH':['o1','ho1'], 
'OHc':['o3','h3\''],
'Sphig':['c1s','h1s','h1t','nf','hnf','c2s','h2s','c3s','h3s','o3','ho3','c4s','h4s','c5s','h5s'],
'FCO':['c1f','of'],
'GlyHd':['c3','hg31','hg32','c2','hg22','og12','ho12','c1','hg11','hg12'],
'Phosd1':['p3','op33','op34','op31','op32','p1','op13','hp13','op14','op11','op12'],
'Phosd2':['p3','op33','op34','op31','op32','p1','op13','op14','op11','op12'],
'Glyd':['c31','h31j','h31k','c11','h11j','h11k','c12','h12j','o12','c13','h13j','h13k','o13','c32','h32j','o32','c33','h33j','h33k','o33'],
'Carbd':['ca1','oa1','cb1','ob1','cc1','oc1','cd1','od1'],
'Wat':['ow','d1w','d2w'], 'Pot':['k']}

# Define head group names for gl,sl,dl and cl
if head == 'pa':
	HGrp=['Acid','Phos','Gly','Carb']; 
elif head == 'pc':
	HGrp=['Chol','Phos','Gly','Carb']; 
elif head == 'pe':
	HGrp=['EolAm','Phos','Gly','Carb']; 
elif head == 'pg':
	HGrp=['GlyH','Phos','Gly', 'Carb']; 
elif head == 'pi':
	HGrp=['Inos','Phos','Gly', 'Carb']; 
elif head == 'ps':
	HGrp=['Ser', 'Phos', 'Gly','Carb']; 
elif 'sm' in lip:
	HGrp=['Chol','Phos','Sphig','FCO']; 
elif 'cer' in lip or 'cr' in lip:
	HGrp=['OH','Sphig','FCO'];
elif 'cl1' in lip:
	HGrp=['GlyHd','Phosd1','Glyd','Carbd']
elif 'cl2' in lip:
	HGrp=['GlyHd','Phosd2','Glyd','Carbd']	
elif lip_type == 'cl':
	HGrp=['OHc']; 
elif lip == 'tip3':
	HGrp=['Wat'];
elif lip == 'pot':
	HGrp=['Pot'];	 


### Tail groups for both All-Atom, and United-Atom lipids All-Atom part
Hatmnlist=[]; Tatmnlist=[]
for i in range(0,len(HGrp),1):
	Hatmnlist=Hatmnlist+HGrpAtms[HGrp[i]]
for line in atmlbl:
	atmn = line.strip().split()
	Tatmnlist.append(atmn[0])
for i in range (0,len(Hatmnlist),1):
	Tatmnlist.remove(Hatmnlist[i])

# Call grpA(Tatmnlist,N_1stc,Ind_c,c_pre,c_suf,h1_suf,h2_suf,h3_suf,ho_suf)
if lip_type == 'gl':
	grpA(Tatmnlist, 2, 1, '2', '', 'r', 's', 't', '1');
	grpA(Tatmnlist, 2, 1, '3', '', 'x', 'y', 'z', '1');
elif lip_type == 'sl':
	grpA(Tatmnlist, 6, -1, '', 's', 's', 't', 'u', '1');
	grpA(Tatmnlist, 2, -1, '', 'f', 'f', 'g', 'h', '1');
elif lip_type == 'dl':
	grpA(Tatmnlist, 2, 1, 'a', '', 'a', 'b', 'c', '1');
	grpA(Tatmnlist, 2, 1, 'b', '', 'd', 'e', 'f', '1');
	grpA(Tatmnlist, 2, 1, 'c', '', 'r', 's', 't', '1');
	grpA(Tatmnlist, 2, 1, 'd', '', 'x', 'y', 'z', '1');
elif lip_type == 'cl':
	grpA(Tatmnlist, 1, '', '', '', 'a', 'b', 'c', '');


### Tail groups for United-Atom lipids
if lip[-1]=='u'and lip_type!= 'tip3':
	TGrpAtms['CH1E']=[];TGrpAtms['CH2E']=[];TGrpAtms['CH3E']=[]
	for line in atmlbl:
		atmn = line.strip().split()
		letters = map(lambda s: s.strip(),atmn[0])
		if letters[0] == 'b':
			TGrpAtms['CH1E'].append(atmn[0])	
		elif letters[0] == 'm':
			TGrpAtms['CH2E'].append(atmn[0])
		elif letters[0] == 't':
			TGrpAtms['CH3E'].append(atmn[0])

NamTgrps=['Cyc','C','CH','CH2','CH3','CH1E','CH2E','CH3E'];
TGrp=[];
if lip[-1]!='u':
	for i in range(0,5,1):
		if len(TGrpAtms[NamTgrps[i]])>=1:
			TGrp.append(NamTgrps[i])
elif lip[-1]=='u':
	for i in range(0,len(NamTgrps),1):
		if len(TGrpAtms[NamTgrps[i]])>=1:
			TGrp.append(NamTgrps[i])

prnA(HGrpAtms,HGrp);
if lip != 'tip3' and lip != 'pot':
	prnA(TGrpAtms,TGrp);

