#!/usr/bin/env python
	
# Authors:Xiaohong Zhuang, Dr.Jeffery B. Klauda
# Date:10/5/2015
	
# This script calculate the total edp of system and cut the edge of lipid bilayer
import numpy as np
import os.path
import collections

# Read in lipid names
filetoread = "lip_lower_all.txt" 
fob=open(filetoread,'r')
lips=fob.readlines()
lip_list = map(lambda s: s.strip(), lips) 

# Calculate the total edp of system
# Read total edp of each gly and sterol lipid
Grpdic={}
for k in range(0,len(lip_list),1):
	Lip=lip_list[k]; Lgrpdic={};
	# Read the group names based on cmp
	filetoread = "%s-nh-grp-names.txt" % Lip
	fob=open(filetoread,'r')
	data=fob.readlines()
	gnames = []
	for line in data:
		gnames.append(line)                       # To generate lists of atom names of all lines, with each line as a string element
	gnames = map(lambda s: s.strip(), gnames)        # To remove \n in each string element
	fob.close()
	gnames = gnames + ['SumC','Total'];
	#print k,Lip,gnames
	
	filetoread = "%s-g-edp.dat" % Lip
	EDP=np.genfromtxt(filetoread,delimiter="\t",skip_header=1); z=EDP[:,0]; zr=z.reshape(-1,1);
	for i in range(0,len(gnames),1):
		Lgrpdic[gnames[i]]= EDP[:,i+1];
		if Grpdic.has_key(gnames[i]):
			Grpdic[gnames[i]]= Grpdic[gnames[i]]+Lgrpdic[gnames[i]];
		else:
			Grpdic[gnames[i]]= Lgrpdic[gnames[i]];

#read in water edp
filetoread = "../tip3.sim"
EDPw=np.genfromtxt(filetoread,delimiter="    ",skip_header=2)
Dw=EDPw[:,1]*1.0+EDPw[:,2]*1.0+EDPw[:,3]*8.0; Dwr=Dw.reshape(-1,1);
Grpdic['Tip3']= Dwr;

# read in pot edp
if os.path.isfile("../pot.sim")== True:
	filetoread = "../pot.sim"
	EDPk=np.genfromtxt(filetoread,delimiter="    ",skip_header=2)
	Dk=EDPk[:,1]*18.0;Dkr=Dk.reshape(-1,1);
	Grpdic['Pot']= Dkr;

EDPtot = Grpdic['Total'].reshape(-1,1);
if os.path.isfile("../pot.sim")== True:
	Grpdic['Total']=EDPtot+Grpdic['Tip3']+Grpdic['Pot'];
else:
	Grpdic['Total']=EDPtot+Grpdic['Tip3'];

# Sort the dictionary by key
Grpdic_sort = collections.OrderedDict(sorted(Grpdic.items()))

j=0	
for key, value in Grpdic_sort.iteritems():
	val=np.array(value).reshape(-1,1); 
	if j==0:
		zD=np.concatenate((zr,val),axis=1)
	else:
		zD=np.concatenate((zD,val),axis=1)
	j+=1

print "Z",
for key, value in Grpdic_sort.iteritems():
	print key,"\t",
print " "

filetowrite = "all-grp-edp.txt"
np.savetxt(filetowrite,zD,fmt='%-2.5f',delimiter='\t')
