#!/usr/bin/env python

# Authors:Xiaohong Zhuang, Dr.Jeffery B. Klauda
# Date:9/12/2015

# This script works for multi-types of lipid bilayer
from Na_Ne import check_Na_Ne                   # import the function check_Na_Ne from module Na_Ne

# Read the lipid name
filetoread = "lip_lower.txt"
fob=open(filetoread,'r')
lip=fob.readline()                           # readline read as str, readlines read as list of each line as element
lip=lip.strip()                              # To remove \n in the end
fob.close()

#############################################################################################################################

# Please update the N_lip, and SA_tot (treat pot and tip3 as lipid components)
# N_lip: Lipid name in LOWER CASE and Number of each lipid,(ion),and water per leaflet
# SA_tot: Averaged total surface area calculated from simulation in Anstromg^2

N_lip = {'cer160':34,'chl1':33,'lign':33,'tip3':2400}
SA_tot= 3373.16

##############################################################################################################################

check_Na_Ne(lip,N_lip[lip],SA_tot)       # Call the check_Na_Ne functions





