home=pwd


% get data for cer160 on top leaflet
cd top/thick-cer160
data=importdata('all-grp-edp.txt');
z=data(:,1);
data=data(:,end-1:end);
cer160top=data(:,2)-data(:,1); %dp for top
cd(home)

% get data for cer160 on bot leaflet
cd bot/thick-cer160
data=importdata('all-grp-edp.txt');
data=data(:,end-1:end);
cer160bot=data(:,2)-data(:,1); %dp for bot
cd(home)

% get data for chl1 on top leaflet
cd top/thick-chl1
data=importdata('all-grp-edp.txt');
data=data(:,end-1:end);
chl1top=data(:,2)-data(:,1); %dp for top
cd(home)

% get data for chl1 on bot leaflet
cd bot/thick-chl1
data=importdata('all-grp-edp.txt');
data=data(:,end-1:end);
chl1bot=data(:,2)-data(:,1); %dp for bot
cd(home)

% get data for lign on top leaflet
cd top/thick-lign
data=importdata('all-grp-edp.txt');
data=data(:,end-1:end);
ligntop=data(:,2)-data(:,1); %dp for top
cd(home)

% get data for lign on bot leaflet
cd bot/thick-lign
data=importdata('all-grp-edp.txt');
data=data(:,end-1:end);
lignbot=data(:,2)-data(:,1); %dp for bot

%calculate interdigitation profile and make NAN 0
cer160=4*(cer160top.*cer160bot)./(cer160top+cer160bot).^2;
cer160(isnan(cer160))=0;
chl1=4*(chl1top.*chl1bot)./(chl1top+chl1bot).^2;
chl1(isnan(chl1))=0;
lign=4*(ligntop.*lignbot)./(ligntop+lignbot).^2;
lign(isnan(lign))=0;

%integrate
cer160int=trapz(z,cer160)
chl1int=trapz(z,chl1)
lignint=trapz(z,lign)
cd(home)

%save variables to dat files
outvar=[z,cer160,chl1,lign]
intvar=[cer160int,chl1int,lignint]
save('profile.dat','outvar','-ASCII')
save('int.dat','intvar','-ASCII')


