#!/bin/csh
#SBATCH --ntasks=1
#SBATCH -N 1
#SBATCH --job-name=t13dig
#SBATCH -t 72:00:00


unset noclobber

# CHANGE TO SUBMISSION SUBDIR
cd $SLURM_SUBMIT_DIR
module load openmpi/1.6
module load fftw/3.3.3/gnu/4.6.1/openmpi/1.6/shared
setenv LD_LIBRARY_PATH $FFTWLIB
# XZ: Turn off the mpi warning as infiniband is being used with the OFED verbs driver.
setenv OMPI_MCA_mpi_warn_on_fork 0 

# CHARMM version
# In DT1
set chm = "/lustre/home/jbklauda/charmm/c40b2/exec/gnu/ifortsse.x11"
# In DT2
#set chm = "/lustre/xzhuang/software/charmm/c39a2/gnu_M/gfortcol.om"
hostname

set file = components.scr
set list = ( `sed '1d' $file | awk '{print $1}'` )
foreach lipid ( $list )
set lip = ( $lipid )

# CHANGE TO SUBMISSION SUBDIR
cd $SLURM_SUBMIT_DIR

# master name and selection list
set alst = $lip-atmlbl.txt

# name list; water only
# set nlst = ( `sed '1d' $alst | grep wat | awk '{print $1}'` )
set nlst = ( `sed '1d' $alst | awk '{print $1}'` )

# mkdir atoms BEFORE running the scritp
rm -rf atoms_$lip
mkdir atoms_$lip

sed '1d' $alst | awk '{print $1,$2,$3}' > alst_nh.txt   # Xiao: Add these two lines to delete the 1st row in atmlbl.txt
set alst_nh = alst_nh.txt                               # However, bld-sim.x is written for atmlbl.txt has a title line 

foreach nm ( $nlst ) 
	set atm = ( `grep $nm $alst_nh | awk '{print $2, $3}'` )
	$chm LIP:$lip ID:$nm SEG:$atm[1] TYP:$atm[2] < getatomnd_1.inp >& atoms_$lip/get$nm.out
	gzip atoms_$lip/get$nm.out
end

rm -f alst_nh.txt 
end

