# Gnuplot script for plotting the equlibration data
# Created by Xiaohong Zhuang on 10/29/2014

set terminal png enhanced font "Arial,30" size 1580,1024
set output '3_tot_edp.tif'
set title ' {/Arial-Bold=45 Total EDP for PSM 45C20P}'
set xlabel ' {/Arial-Bold=40 Z []}'
set ylabel '{/Arial-Bold=40 Electron Density [^{-3}]}' 
set xtics font  "Arial-Bold,40" 
set ytics font  "Arial-Bold,40"
#set xtics 10,5,70
set xtics auto
set ytics auto
#set mxtics 2
set grid
set key center bottom
# set key samplen (line width) and then key box setting: spacing....
set key samplen 3 spacing 1.5 width 2 height 2
# set key font ",40"
 set tmargin 3
 set bmargin -3
 set lmargin 11
 set rmargin 2
set pointsize 1
# set xzeroaxis 
set border lw 3
set bar 0
# show margin  
plot [-40:40] [0:0.55] \
'tot_edp.txt' using 1:2 with line lw 10 lc rgb 'blue' title '{/Arial-Bold=45 Full EDP.}', \
'tot_edp_cut.txt' using 1:2 with line lw 6 lc rgb 'red' title '{/Arial-Bold=45 Cut EDP.}'

