      program bldsim
! builds a .sim file for Nagle+Kuczera SIM2EXP from individual atom profiles
! can combine data from up to 3 replicate simulations

      implicit none
      integer :: i,j,k,l,n, ie,nat,nbn,npn(3),nsm
      integer, parameter :: mxat=6000,mxbn=1000
      real :: adt(mxbn,mxat), t,d, bn(mxbn)
      character(256) :: tmp,str
      character(80) :: spn(3)
      character(7) :: snm,slbl(mxat)

      j = iargc()
      if (j.eq.3) then
        nsm = 1
      else if (j.eq.5) then
        nsm = 3
      else
       write(6,*) 'bldsim.x atom-list subdir [subdir2 subdir3] outfile'
       stop 'Karl Rove'
      endif
      
      call getarg(1,str)
      k=index(str,' ') - 1
      open(10,file=str(1:k),form='formatted',status='old',iostat=ie)
      if (ie/=0) then
        write(6,*) 'Error ',ie,' while opening ',str(1:k)
        stop 'Karl Rove'
      endif
      read(10,'(A)') tmp

      do k=1,nsm
        call getarg(k+1,spn(k))
        npn(k)=index(spn(k),' ') - 1
      enddo

      nat=0
      nbn=0
      adt = 0.0
      do i=1,mxat
        read(10,'(A7)',iostat=ie) snm
        if (ie<0) exit
        j=index(snm,'	') - 1
        if (j<=0) j=7
        slbl(i)=snm(1:j)
        do k=1,nsm
          tmp=spn(k)(1:npn(k))//'/'//snm(1:j)//'.dat'   ! change '/atoms/' to '/' in order to change path
          l=index(tmp,' ') - 1
          open(k,file=tmp(1:l),form='formatted',status='old',iostat=ie)
          if (ie/=0.and.i==1) then
            write(6,*) 'Error ',ie,' while opening ',tmp(1:l)
            stop 'Karl Rove'
          else if (ie/=0) then
            write(6,*) 'Error ',ie,' opening ',tmp(1:l),' skipping'
            if (k==1) nat = nat - 1
            exit
          endif
          read(k,'(A)') tmp
          do n=1,mxbn
            read(k,*,iostat=ie) t,d
            adt(n,i) =  adt(n,i) + d
            bn(n) = t
            if (ie<0) then
              exit
            else if (ie>0) then
              write(6,*) 'Error ',ie,' while reading ',tmp(1:l)
              write(6,*) 'bin=',n,' atom=',i,' rep=',k
              stop 'Karl Rove'
            endif
          enddo
          nbn=n-1
        enddo
        nat = nat + 1
        if (nsm.eq.3) then
          t = 1./3.
          adt(1:nbn,i) =  adt(1:nbn,i) * t
        endif
      enddo
      write(6,*) 'Nbins= ',nbn,'  Natom=',nat
      call getarg(nsm+2,str)
      n=index(str,' ') - 1
      open(11,file=str(1:n),form='formatted')
C      write(11,*) '## Nbins= ',nbn, '  Natom=',nat, '  ',  
C     1  (spn(j)(1:1+npn(j)),j=1,nsm),' ',str(1:n)
      write(11,101) nbn,nat, (spn(j)(1:1+npn(j)),j=1,nsm),str(1:n)
 101  format('## Nbins= ',I4,'  Natom=',I4,3X,3A16,3X,A24)
      write(11,'(301A11)') 'Zbin  ',(slbl(j),j=1,nat)
      do i=1,nbn
        write(11,'(301F11.5)') bn(i),(adt(i,j),j=1,nat)
      enddo

      stop
      end program

