#!/usr/bin/env python
	
# Authors:Xiaohong Zhuang, Dr.Jeffery B. Klauda
# Date:10/5/2015
	
# This script calculate total edp of each lipid
import numpy as np

# Read lipid name
fob = open('lip_lower.txt','r')
lip = fob.readline()
lip = lip.strip()
fob.close()

# Read and generate index based on atom names in *sim
filetoread = "%s-atms.txt" % lip
fob=open(filetoread,'r')
atmn_sim=fob.readline() 
atmn_sim=atmn_sim.split()
fob.close()

# Read *.sim for atomic density
filetoread = "%s-nh2c1.sim" % lip
sim_nz=np.genfromtxt(filetoread,delimiter=" ")

# Expected No. of electrons of common atoms. (b(CH1E),m(CH2E),t(CH3E) are united atoms)
# Treat d as h, use d just to have different neutron scattering lengths defined in SIMtoEXP 
N_e={'h':1,'d':1,'c':6,'n':7,'o':8,'p':15,'s':16,'b':7,'m':8,'t':9,'k':18}

for i in range(0,len(atmn_sim),1):
	letters = map(lambda s: s.strip(), atmn_sim[i])
	sim_nz[:,i]=sim_nz[:,i]*N_e[letters[0]]
Tot_Row=np.sum(sim_nz,axis=1)
Dr=Tot_Row.reshape(-1,1)

# Read *.sim for bins
filetoread = "%s-nh2.sim" % lip
sim=np.genfromtxt(filetoread,delimiter="    ")
z=sim[:,0];zr=z.reshape(-1,1)
zD=np.concatenate((zr,Dr),axis=1)

filetowrite = "%s-edp.txt" % lip
np.savetxt(filetowrite,zD,fmt='%-2.5f',delimiter='    ')
