# Gnuplot script for plotting the equlibration data
# Created by Xiaohong Zhuang on 10/29/2014

set terminal png enhanced font "Arial,30" size 1580,1024
inptitle=system("cat inptitle.txt")
outptitle=system("cat outptitle.txt")
set output outptitle

#set output '3_tot_edp.tif'
#set title ' {/Arial-Bold=45 Total EDP}'
set xlabel ' {/Arial-Bold=60 Z []}'
set ylabel '{/Arial-Bold=50 Electron Density [^{-3}]}' 
set xtics font  "Arial-Bold,50" 
set ytics font  "Arial-Bold,50"
#set xtics 10,5,70
set xtics auto
set ytics 0,0.1,0.5
set mytics 2
#set grid
set key center top
# set key samplen (line width) and then key box setting: spacing....
set key samplen 3 spacing 1.5 width 2 height 2
# set key font ",40"
 set tmargin 3
 set bmargin -3
 set lmargin 13
 set rmargin 2
set pointsize 1
# set xzeroaxis 
set border lw 3
set bar 0
# show margin  
plot [-50:50] [0:0.5] \
inptitle using 1:3 with line lw 8 lc rgb 'black' title '{/Arial-Bold=50 C}', \
inptitle using 1:4 with line lw 8 lc rgb 'red' title '{/Arial-Bold=50 CH}', \
inptitle using 1:5 with line lw 8 lc rgb 'pink' title '{/Arial-Bold=50 CH2}', \
inptitle using 1:6 with line lw 8 lc rgb 'navy' title '{/Arial-Bold=50 CH3}', \
inptitle using 1:7 with line lw 8 lc rgb '#008000' title '{/Arial-Bold=50 COOH}', \
inptitle using 1:8 with line lw 8 lc rgb 'blue' title '{/Arial-Bold=50 FCO}', \
inptitle using 1:9 with line lw 8 lc rgb '#FFD700' title '{/Arial-Bold=50 OH}', \
inptitle using 1:10 with line lw 8 lc rgb 'purple' title '{/Arial-Bold=50 OHc}', \
inptitle using 1:11 with line lw 8 lc rgb 'green' title '{/Arial-Bold=50 Sphig}', \
inptitle using 1:12 with line lw 8 lc rgb 'brown' title '{/Arial-Bold=50 SumC}', \
inptitle using 1:13 with line lw 8 lc rgb 'orange' title '{/Arial-Bold=50 Tip3}', \
inptitle using 1:14 with line lw 8 lc rgb '#6495ED' title '{/Arial-Bold=50 Tot}'