#!/usr/bin/env python
	
# Authors: Xiaohong Zhuang, Dr.Jeffery B. Klauda
# Date: 11/5/2015
	
# This script calculate the thicknesses DHH,DB, and DC
import numpy as np

def calc_thicknesses():
	filetoread = "All-grps-edp-cut.txt" 
	zedp=np.genfromtxt(filetoread,delimiter="\t",skip_header=1,)
	#z=edp[:,0];zr=z.reshape(-1,1)	
	Nrow=np.shape(zedp)[0]; Nn=Nrow/2;


	# Find DHH
	Tot_mx_n=np.amax(zedp[0:Nn,-1],axis=0);Tot_mx_p=np.amax(zedp[Nn+1:,-1],axis=0);
	In=np.argmax(zedp[0:Nn,-1],axis=0); Ip=np.argmax(zedp[Nn+1:,-1],axis=0);
	DHH_n = zedp[In,0]; DHH_p = zedp[Nn+Ip+1,0]; 
	DHH = DHH_p - DHH_n ; 

	# Find DB
	# find V_w at edge
	Rho_max_w_n=np.amax(zedp[0:Nn,-2],axis=0); Rho_mid_w_n=Rho_max_w_n/2.0;

	Rho_max_w_p=np.amax(zedp[Nn+1:,-2],axis=0); Rho_mid_w_p=Rho_max_w_p/2.0;
	#if 'Pot' in gnames:
		#In=np.argmax(zedp[0:Nn,-2],axis=0); Ip=np.argmax(zedp[Nn+1:,-2],axis=0);
		#V_k=40.7/18.0; Rho_k_n = zedp[In,-2]; Rho_k_p = zedp[Nn+Ip+1,-2];
		# With small trace of K+ present on the edge, the Rho_w is lower. 
		#Rho_mid_w_n = Rho_mid_w_n/(1.0-V_k*Rho_k_n); Rho_mid_w_p = Rho_mid_w_p/(1.0-V_k*Rho_k_p);
	# Change Nn-150 and Nn+150 to 0 and blank to return to original code
	DB_n=np.interp(Rho_mid_w_n, np.flipud(zedp[Nn-150:Nn,-2]), np.flipud(zedp[Nn-150:Nn,0]));
	DB_p=np.interp(Rho_mid_w_p, zedp[Nn+1:Nn+150,-2], zedp[Nn+1:Nn+150,0]);
	DB = DB_p - DB_n; 

	# Find 2DC
	# find V_c at z=0 , take average of -0.1 and 0.1 
	#Rho_max_c=(zedp[Nn-1,-3]+zedp[Nn,-3])/2.0; Rho_mid_c=Rho_max_c/2.0;
	Rho_max_c_n=np.amax(zedp[0:Nn,-3],axis=0); Rho_mid_c_n=Rho_max_c_n/2.0;
	Rho_max_c_p=np.amax(zedp[Nn+1:,-3],axis=0); Rho_mid_c_p=Rho_max_c_p/2.0;
	Rho_max_c=(Rho_max_c_n + Rho_max_c_p)*0.5; Rho_mid_c=(Rho_mid_c_n + Rho_mid_c_p)*0.5;
	#In=np.argmax(zedp[0:Nn,-3],axis=0); Ip=np.argmax(zedp[Nn+1:,-3],axis=0);
	DC_n=np.interp(Rho_mid_c_n, zedp[0:Nn,-3], zedp[0:Nn,0]);
	DC_p=np.interp(Rho_mid_c_p, np.flipud(zedp[Nn+1:,-3]), np.flipud(zedp[Nn+1:,0]));
	DC = DC_p - DC_n; 

	# print the results
	print 'DHH\t%2.2f\t%2.2f\t%2.2f\t%2.4f\t%2.4f' % (DHH,DHH_p,DHH_n,Tot_mx_n,Tot_mx_p)
	print 'DB\t%2.2f\t%2.2f\t%2.2f\t%2.4f\t%2.4f' % (DB,DB_p,DB_n,Rho_max_w_n,Rho_mid_w_n)
	print '2DC\t%2.2f\t%2.2f\t%2.2f\t%2.4f\t%2.4f' % (DC,DC_p,DC_n,Rho_max_c,Rho_mid_c)

calc_thicknesses()
